/*
 * Created on 2004/07/01
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.io;

import java.io.IOException;
import java.io.InputStream;

/**
 * 
 *
 */
public class LineSeparatorChangeInputStream extends InputStream{
private InputStream input;
private String lineSeparator;
    /* (non-Javadoc)
     * @see java.io.InputStream#read()
     */
private String datas;
public LineSeparatorChangeInputStream(InputStream input,String lineSeparator){
    this.input=input;
    this.lineSeparator=lineSeparator;
}
protected String lineRead() throws IOException{
   if(lineSeparator==null){
       throw new RuntimeException("LineSeparatorChangeInputStream:lineSeparator == null");
   }
   StringBuffer result=new StringBuffer();
   boolean isPreR=false;
   while(true){
       int read=input.read();
       if(read==-1){
           if(isPreR)
               result.append(lineSeparator);
           break;
       }
          
       else{
           if(read==(int)'\r')
               isPreR=true;
           else if(read==(int)'\n'){
               result.append(lineSeparator);
               break;
           }else{
               if(isPreR){
                   result.append(lineSeparator);
                   isPreR=false;
                   result.append((char)read);
                   break;
               }else{
                   result.append((char)read);
               }
              
           }
       }
   }
   
   if(result.length()==0)
       return null;
   
   return result.toString();
}
public int read() throws IOException {
int ret=-1;
if(datas!=null){
    ret=(int)datas.charAt(0);
    datas=datas.substring(1);
    if(datas.length()==0)
        datas=null;
}else{
    datas=lineRead();
    if(datas!=null)
        return read();
}

        // TODO Auto-generated method stub
        return ret;
    }

/**
 * @return Returns the lineSeparator.
 */
public String getLineSeparator() {
    return lineSeparator;
}
/**
 * @param lineSeparator The lineSeparator to set.
 */
public void setLineSeparator(String lineSeparator) {
    this.lineSeparator = lineSeparator;
}
}
