package org.jpn.xucker.commons.swt.series.wfs;/*
                 * Created on 2004/06/27
                 * 
                 * Author aki@www.xucker.jpn.org License Apache2.0 or Common
                 * Public License
                 */

import java.io.File;
import java.io.IOException;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CCombo;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetAdapter;
import org.eclipse.swt.dnd.DropTargetEvent;
import org.eclipse.swt.dnd.FileTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.DirectoryDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.Text;
import org.jpn.xucker.commons.swt.series.FileListTypeMenu;
import org.jpn.xucker.commons.swt.series.PropertyMenuListener;
import org.jpn.xucker.commons.swt.series.ResultData;
import org.jpn.xucker.commons.swt.series.ResultDialog;
import org.jpn.xucker.commons.swt.ui.FileStatusChangeEvent;
import org.jpn.xucker.commons.swt.ui.FileStatusChangeListener;
import org.jpn.xucker.commons.swt.ui.FileListTable;
import org.jpn.xucker.commons.swt.ui.OkCancelDialog;
import org.jpn.xucker.commons.swt.ui.OkCancelDialogListener;
import org.jpn.xucker.commons.util.ApplicationUtil;
import org.jpn.xucker.commons.util.FileProperties;


public abstract class WrapperFileStandard implements SelectionListener ,FileStatusChangeListener,OkCancelDialogListener,PropertyMenuListener{
    /**
     * @param shell
     */
    protected Group group1;

    protected Button sameoutput;

    protected Text outputLabel;

    protected Button outputButton;

    protected Group optionGroup;

   

    protected Button executeButton;

    protected Group group3;

    protected Table table1;

    protected Group group4;

    protected CCombo level;

    //protected Text commandPathLabel;

    //protected Button commandPathButton;

    protected FileListTable listTable;

    protected Shell shell;

    protected Image logoImage;

    protected double version=0.1;
    protected String url="http://www.xucker.jpn.org/";
    protected String APP_NAME="Wrapper";
    protected String defaultCommandPath;
    protected String logoPath;
    protected String iconPath;

    protected String commandName;
    protected String exeName="exe";
    
    protected String[] resultLabels;
    protected int[] resultWidths;

    protected String sameoutputLabel="͂Ɠӏ֏o";
    
    protected String settingLabel="ݒ";

    protected String execLabel="s";
    protected String[] allowFileExtension;
    protected String myselfExeName;
    protected String propertyName="conf.properties";

    protected FileProperties fileProperties;
    protected String outputExtension;
    public static final String COMMAND_PATH="COMMAND_PATH";

    protected RowData table_rowdata;

    protected RowData output_rowdata;

    protected RowData option_rowdata;
    public WrapperFileStandard(Shell shell) {
        this.shell = shell;
        beforeInit();
        loadProperties();
        shell.setImage(new Image(Display.getCurrent(), WrapperFileStandard.class
                .getClassLoader().getResourceAsStream(
                        iconPath)));
        
        shell.setText(APP_NAME+" "+version);
        shell.setBounds(0, 0, 500, 400);
        RowLayout layout = new RowLayout();
        shell.setLayout(layout);
        
        
        //
        

        group3 = new Group(shell, SWT.NULL);
        group3.setText("");
        RowData group3_data = new RowData();
        group3_data.width = 480;
        group3.setLayoutData(group3_data);
        RowLayout group3_layout = new RowLayout();
        group3.setLayout(group3_layout);

        listTable = new FileListTable(group3, SWT.NULL);
        listTable.addFileListChangeListener(this);
        
        listTable.setFileExtension(allowFileExtension);
        table1 = listTable.getTable();
        table1.setLinesVisible(true);

        table_rowdata = new RowData();
        table_rowdata.width = 455;
        table_rowdata.height = 130;
        table1.setLayoutData(table_rowdata);
        TableColumn table1_column = new TableColumn(table1, SWT.NULL);
        table1_column.setWidth(470);
        //o
        group1 = new Group(shell, SWT.NULL);
        group1.setText("o");
        output_rowdata = new RowData();
        output_rowdata.width = 480;
        group1.setLayoutData(output_rowdata);
        RowLayout group1_layout = new RowLayout();
        group1.setLayout(group1_layout);

        sameoutput = new Button(group1, SWT.NULL | SWT.CHECK);
        sameoutput.setText(sameoutputLabel);
        sameoutput.addSelectionListener(this);
        RowData sameoutput_data = new RowData();
        sameoutput.setLayoutData(sameoutput_data);

        outputLabel = new Text(group1, SWT.READ_ONLY);
        outputLabel.setText("");
        outputLabel
                .setBackground(new Color(Display.getCurrent(), 255, 255, 255));
        RowData outputLabel_data = new RowData();
        outputLabel_data.width = 200;
        outputLabel.setLayoutData(outputLabel_data);

        Transfer[] types = new Transfer[] { FileTransfer.getInstance() };

        int operations = DND.DROP_MOVE | DND.DROP_COPY;

        DropTarget target2 = new DropTarget(outputLabel, operations);
        target2.setTransfer(types);

        target2.addDropListener(new DropMonitor());

        //o͐tH_[
        outputButton = new Button(group1, SWT.NULL);
        outputButton.setText("o͐tH_[");
        outputButton.addSelectionListener(this);
        RowData outputButton_data = new RowData();
        outputButton.setLayoutData(outputButton_data);

        optionGroup = new Group(shell, SWT.NULL);
        optionGroup.setText("IvV");
        option_rowdata = new RowData();
        option_rowdata.width = 480;
        optionGroup.setLayoutData(option_rowdata);
        RowLayout group2_layout = new RowLayout();
        optionGroup.setLayout(group2_layout);

        


        //s
        executeButton = new Button(shell, SWT.NULL);
        executeButton.setText(execLabel);
        executeButton.setEnabled(false);
        executeButton.addSelectionListener(this);
        shell.setBackground(new Color(Display.getCurrent(), 255, 255, 255));
        RowData optimizeButton_data = new RowData();
        optimizeButton_data.width = 130;
        optimizeButton_data.height = 50;

        executeButton.setLayoutData(optimizeButton_data);
        
        
         logoImage = new Image(Display.getCurrent(), FileListTable.class
                .getClassLoader().getResourceAsStream(
                        logoPath));

        Label canvas = new Label(shell, SWT.NULL);
        canvas.setImage(logoImage);
        RowData canvas_data = new RowData();
        canvas_data.width = 350;
        canvas_data.height = 50;
        canvas.setLayoutData(canvas_data);

       

        FileListTypeMenu menu=new FileListTypeMenu(shell,listTable,version,url,APP_NAME);
        menu.setListener(this);
        /*
        Label label=new Label(group4,SWT.NULL);
        label.setText("x");
        level = new CCombo(group4, SWT.NULL);
        for(int i=0;i<=7;i++){
            level.add(""+i);
        }
        
        level.select(7);
        level.addSelectionListener(this);
        RowData level_data = new RowData();
        level.setLayoutData(level_data);
*/
       

        sameoutput.setSelection(true);
        do_sameoutput();
        afterInit();
    }
    
    /**
     * 
     */
    private void loadProperties() {
        File exeFile=ApplicationUtil.searchFileAroundClass(myselfExeName);
        //System.out.println(exeFile);
        if(exeFile!=null){
            File propertyFile=new File(exeFile.getParent(),propertyName);
            fileProperties = new FileProperties(propertyFile);
        }
    }
    
    private void saveProperties(){
        
        if(fileProperties!=null){
        // System.out.println("call save "+fileProperties.getFilePath());
        fileProperties.save();
        }
    }

    protected abstract void beforeInit();
    protected abstract void afterInit();

    

    public void widgetSelected(SelectionEvent event) {
        Object target = event.getSource();
        
        //͂Ɠ
       if (target == sameoutput) {
            do_sameoutput();
        }
        //o͐tH_[
        else if (target == outputButton) {
            do_outputButton();
        }
       
        //œK
        else if (target == executeButton) {
            do_executeButton();
        }
        //null1
        else if (target == table1) {
            do_table1();
        }

       
        

    }

    public void widgetDefaultSelected(SelectionEvent arg0) {
       
    }

    //͂Ɠ
    private void do_sameoutput() {
        if (sameoutput.getSelection()) {
            outputButton.setEnabled(false);
            outputLabel.setEnabled(false);
        } else {
            outputButton.setEnabled(true);
            outputLabel.setEnabled(true);
        }

        checkExecuteButton();
    }

    //o͐tH_[
    public void do_outputButton() {
        DirectoryDialog dialog = new DirectoryDialog(shell, SWT.OPEN);
        String file = dialog.open();
        if (file != null) {
            outputLabel.setText(file);
        }
        
        checkExecuteButton();
    }

    

    //s
    public void do_executeButton() {
        executeButton.setEnabled(false);
        
        File commandFile=null;
        String commandPath=fileProperties.get(COMMAND_PATH);
        if(commandPath!=null && !commandPath.equals("")){
            commandFile=new File(commandPath);
            if(!commandFile.exists()){
                commandFile=null;
            }
        }
        if(commandFile==null){
            //find directPath
            
            //optiPngFile=searchFileAroundClass("optipng.exe");
            commandFile=new File(defaultCommandPath);
        }
        
        if(commandFile==null){
            //alert
            MessageBox dialog=new MessageBox(shell,SWT.ICON_ERROR);
            dialog.setText("G[");
            dialog.setMessage(exeName+" ܂");
            dialog.open();
        }else{
            WrapperExecuter executer=createWrapperExecuter();
            executer.setResultLabel(resultLabels);
            executer.setCommandPath(commandFile.getAbsolutePath());
            executer.setOutputExtension(outputExtension);
            executer.setAllowExtension(allowFileExtension);
           
           
            
            if(outputLabel.getText().length()>0 && sameoutput.getSelection()==false){
                executer.setOutput(new File(outputLabel.getText()));
            }
            
            String files[]=listTable.getFiles();
            for(int i=0;i<files.length;i++){
                executer.addFile(files[i]);
            }
            try {
                executer.execute();
            } catch (IOException e) {
            
                e.printStackTrace();
            }
            
            ResultData[] data=executer.getResultData();
            Shell childShell=new Shell(shell);
            
            
            
            ResultDialog dialog=new ResultDialog(childShell,resultLabels,resultWidths);
            dialog.setResultData(data);
            childShell.open();
        }
        
        executeButton.setEnabled(true);
    }

    /**
     * @return
     */
    protected abstract WrapperExecuter createWrapperExecuter();

    //null1
    public void do_table1() {
        System.out.println("table1");
    }

    //null1
    public void do_menu1() {
        System.out.println("menu1");
    }

    //t@Cǉ
    public void do_addFileMenu() {
        System.out.println("addFileMenu");
    }

    //tH_[ǉ
    public void do_addFolderMenu() {
        System.out.println("addFolderMenu");
    }

    
    

    public class DropMonitor extends DropTargetAdapter {
        public void dragEnter(DropTargetEvent event) {
            //System.out.println("drag enter:"+event.data);
        }

        public void dragOver(DropTargetEvent event) {
            //System.out.println("drag over:"+event.data);
        }

        public void drop(DropTargetEvent event) {
            //System.out.println("drop:"+event.data);

            //System.out.println(event.data.getClass().getName());
            String files[] = (String[]) event.data;
            String tmpText = "";
            for (int i = 0; i < files.length; i++) {
                File file = new File(files[i]);
                if (file.isDirectory()) {
                    outputLabel.setText(files[i]);
                }

            }

        }
    }

    /* (non-Javadoc)
     * @see optipng.FileListChangeListener#removeList(optipng.FileListChangeEvent)
     */
    public void removeList(FileStatusChangeEvent event) {
        checkExecuteButton();}

    
    /**
     * 
     */
    protected void checkExecuteButton() {
        if(listTable.getFileCount()>0 && (sameoutput.getSelection() || outputLabel.getText().length()>0)){
            executeButton.setEnabled(true);
        }else{
            executeButton.setEnabled(false);
        }
    }

    /* (non-Javadoc)
     * @see optipng.FileListChangeListener#addList(optipng.FileListChangeEvent)
     */
    public void addList(FileStatusChangeEvent event) {
        checkExecuteButton();
    }
    
    
    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.swt.ui.OkCancelDialogListener#clickOkButton(org.jpn.xucker.commons.swt.ui.OkCancelDialog)
     */
    public void clickOkButton(OkCancelDialog dialog) {
       String command=dialog.getValue(COMMAND_PATH);
       //System.out.println(command);
       if(command!=null){
           if(fileProperties!=null){
               fileProperties.set(COMMAND_PATH,command);
               saveProperties();
           }
       }
    }
    

    
    

}