/*
 * Created on 2004/12/05
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.commons.undo;

import java.util.List;
import java.util.Vector;


/**
 * 
 *
 */
public class CommandControl {
List commandList=new Vector();
int index=-1;

public List getCommandList(){
    return commandList;
}
public int getIndex(){
    return index;
}
public synchronized void addCommand(Command command){
    List undoList=new Vector();
    for(int i=index+1; i<commandList.size();i++){
        undoList.add(commandList.get(i));
    }
    //commandList.removeAll(undoList);
    for(int i=0;i<undoList.size();i++){
        UndoCommand undoCommand=new UndoCommand();
        undoCommand.setCommand((Command)undoList.get(i));
        commandList.add(undoCommand);
    }
    commandList.add(command);
    index=commandList.size()-1;
}
public boolean canUndo(){
    return index>=0;
}

public boolean canRedo(){
    return commandList.size()>0 && index<commandList.size()-1;
}

public synchronized void undo(){
    if(canUndo()){
    Command command=getCommandAt(index);
    command.unexecute();
    index--;
    }
}

public synchronized  void redo(){
    if(canRedo()){
        Command command=getCommandAt(index+1);
        command.execute();
        index++;
    }
}

public Command getCommandAt(int index){
    return (Command)commandList.get(index);
}
}
