/*
 * Created on 2004/07/03 Author aki@www.xucker.jpn.org License Apache2.0 or
 * Common Public License
 */
package org.jpn.xucker.tab2tree;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.events.ShellListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Text;

import java.util.Properties;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang.StringUtils;
import org.jpn.xucker.commons.property.StatusChangeListener;
import org.jpn.xucker.commons.property.StatusChangeMonitor;
import org.jpn.xucker.commons.swt.ui.SWTBasicFileApplication;
import org.jpn.xucker.commons.swt.ui.SWTStatusChangedMonitor;
import org.jpn.xucker.commons.util.ApplicationProperties;
import org.jpn.xucker.commons.util.ApplicationUtil;
import org.jpn.xucker.commons.util.FileProperties;
import org.jpn.xucker.freemind.FreeMindUtils;
import org.jpn.xucker.freemind.Map;
import org.jpn.xucker.tree.StringTree;
import org.jpn.xucker.tree.StringTreeBuilder;
import org.jpn.xucker.tree.view.TabToTreeView;
import org.picocontainer.MutablePicoContainer;
import org.picocontainer.Parameter;
import org.picocontainer.defaults.ConstantParameter;
import org.picocontainer.defaults.DefaultPicoContainer;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;

import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;

public class Main extends SWTBasicFileApplication implements SelectionListener, ModifyListener, ShellListener,StatusChangeListener {
    private float version = (float) 0.7;

  

   

  



    private Properties properties;

    private Combo splitWordText;

    private Button isParseLinkButton;

    private static final String FileEncoding = System
            .getProperty("file.encoding");

  

    StatusChangeMonitor statusChangeMonitor;
    public static void main(String[] args) {
        Display display=null;
        try{
         display= new Display();
        Shell shell = new Shell(display);
        Image t2tImage = new Image(display, Main.class.getClassLoader()
                .getResourceAsStream("org/jpn/xucker/tab2tree/resource/t2t.png"));
        shell.setImage(t2tImage);
        //main not use.
        Main main = new Main(shell);
        main.init();
        shell.open();

        if (args.length > 0) {
            main.readText(new File(args[0]));
        }

        while (!shell.isDisposed()) {
            if (!display.readAndDispatch()) {
                display.sleep();
            }
        }
        display.dispose();
        }catch(Exception e){
            e.printStackTrace();
        }finally{
            display.dispose();
            System.exit(1);
        }
    }

    private Text textText;

    private Text treeText;

    private TabFolder tab;

    private Combo list;

    private String appName="Tab2Tree eLXg";



    private String LINE_SEPARATOR="lineSeparator";
private String ISLINK="isLink";


    private String SPLIT_WORD="splitWord";



    private Button updateButton;
    /**
     * @param shell
     */
    
    private static String EXE_NAME="tab2tree.exe";



    private MutablePicoContainer picoContainer;



    private ApplicationProperties applicationProperties;
    
    public Main(Shell shell) {
        this.shell = shell;
       
    }
    public void init(){
        picoContainer = loadContainer();
        loadProperties();
        
        
        this.setFileExtension("txt");
        shell.addShellListener(this);
        
        
        
        updateTitle();
        Rectangle rect = Display.getCurrent().getPrimaryMonitor().getBounds();
        int w = 400;
        int h = 400;

        Menu menuBar = new Menu(shell, SWT.BAR);

        shell.setMenuBar(menuBar);

        MenuItem mitem = new MenuItem(menuBar, SWT.CASCADE);

        Menu fileMenu = new Menu(shell, SWT.DROP_DOWN);
        mitem.setText("t@C");
        mitem.setMenu(fileMenu);

        MenuItem newItem = new MenuItem(fileMenu, SWT.PUSH);
        newItem.setText("VK");
        newItem.addSelectionListener(this);

        MenuItem openItem = new MenuItem(fileMenu, SWT.PUSH);
        openItem.setText("J");
        openItem.addSelectionListener(this);

        MenuItem saveItem = new MenuItem(fileMenu, SWT.PUSH);
        saveItem.setText("ۑ");
        saveItem.addSelectionListener(this);

        MenuItem saveAsItem = new MenuItem(fileMenu, SWT.PUSH);
        saveAsItem.setText("ʖŕۑ");
        saveAsItem.addSelectionListener(this);

        MenuItem sepalator = new MenuItem(fileMenu, SWT.SEPARATOR);
        sepalator.getData();//for PMD

        MenuItem exitItem = new MenuItem(fileMenu, SWT.PUSH);
        exitItem.setText("I");
        exitItem.addSelectionListener(this);

        MenuItem mitem2 = new MenuItem(menuBar, SWT.CASCADE);
        Menu treeMenu = new Menu(shell, SWT.DROP_DOWN);
        mitem2.setText("c[");
        mitem2.setMenu(treeMenu);

        MenuItem copyItem = new MenuItem(treeMenu, SWT.PUSH);
        copyItem.setText("Nbv{[hփRs[");
        copyItem.addSelectionListener(this);
        MenuItem tmpItem = new MenuItem(treeMenu, SWT.SEPARATOR);
        tmpItem.getEnabled();
        
        MenuItem writeFileItem = new MenuItem(treeMenu, SWT.PUSH);
        writeFileItem.setText("t@C֕ۑ");
        writeFileItem.addSelectionListener(this);
        
        MenuItem freemindFileItem = new MenuItem(treeMenu, SWT.PUSH);
        freemindFileItem.setText("FreeMind `ŏo");
        freemindFileItem.addSelectionListener(this);

        MenuItem mitem3 = new MenuItem(menuBar, SWT.CASCADE);
        Menu helpMenu = new Menu(shell, SWT.DROP_DOWN);
        mitem3.setText("wv");
        mitem3.setMenu(helpMenu);

        MenuItem versionItem = new MenuItem(helpMenu, SWT.PUSH);
        versionItem.setText("o[W");
        versionItem.addSelectionListener(this);

        shell.setLayout(new FillLayout());
        shell.setBounds((rect.width - w) / 2, (rect.height - h) / 2, w, h);
        tab = new TabFolder(shell, SWT.NULL);
        tab.addSelectionListener(this);
        TabItem textItem = new TabItem(tab, SWT.NULL);
        textItem.setToolTipText("ɃeLXgTabŒiē͂܂B\r\năc[Text^uɐ؂ւ܂B");
        textItem.setText("eLXg");

        textItem.setImage(new Image(Display.getCurrent(), Main.class
                .getClassLoader().getResourceAsStream(
                        "org/jpn/xucker/tab2tree/resource/abc.png")));

        Composite composite=new Composite(tab,SWT.NULL);
        composite.setLayout(new GridLayout(3,false));
        Button mindButton=new Button(composite,SWT.NULL);
        mindButton.addSelectionListener(new CallMind());
        mindButton.setText("FreeMindN");
        
        Button takahashiIndex=new Button(composite,SWT.NULL);
        takahashiIndex.setText("indexL \bh");
        takahashiIndex.addSelectionListener(new TakahashiMethodSelect(true));
        
        Button takahashi2=new Button(composite,SWT.NULL);
        takahashi2.setText("m[} \bh");
        takahashi2.addSelectionListener(new TakahashiMethodSelect(false));
        
        textText = new Text(composite, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);
        textText.addModifyListener(this);
        GridData data=new GridData(GridData.FILL_BOTH);
        data.horizontalSpan=3;
        textText.setLayoutData(data);
        textItem.setControl(composite);
        

        TabItem tabItem = new TabItem(tab, SWT.MULTI);
        
        StringBuffer tabItem_tooltip=new StringBuffer();
        tabItem_tooltip.append("ɂ̓eLXg^uœ͂eLXgc[`ɕϊꂽ̂o͂܂B"+System.getProperty("line.separator"));
        tabItem_tooltip.append("sύXɂ͐ݒ^u"+System.getProperty("line.separator"));
        tabItem_tooltip.append(""+System.getProperty("line.separator"));
        tabItem_tooltip.append("HTML̃N`ɂɂ̓ftHgł,ŋ؂eLXg^uɓ͂܂B"+System.getProperty("line.separator"));
        tabItem.setToolTipText(tabItem_tooltip.toString());

        tabItem.setText("c[Text");
        tabItem.setImage(new Image(Display.getCurrent(), Main.class
                .getClassLoader().getResourceAsStream(
                        "org/jpn/xucker/tab2tree/resource/tree.png")));

        treeText = new Text(tab, SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL);

        tabItem.setControl(treeText);

        TabItem settingItem = new TabItem(tab, SWT.MULTI);
        StringBuffer text=new StringBuffer();
        text.append("ŐݒeύX܂B"+System.getProperty("line.separator"));
        text.append("ύXłéA"+System.getProperty("line.separator"));
        text.append("link쐬邩"+System.getProperty("line.separator"));
        text.append("link쐬̕"+System.getProperty("line.separator"));
        text.append("Nbv{[hփRs[t@Cỏ͎sR[h"+System.getProperty("line.separator"));
        text.append("łB"+System.getProperty("line.separator"));
        settingItem.setToolTipText(text.toString());
        settingItem.setText("ݒ");
        settingItem.setImage(new Image(Display.getCurrent(), Main.class
                .getClassLoader().getResourceAsStream(
                        "org/jpn/xucker/tab2tree/resource/set.png")));

        Composite panel = new Composite(tab, SWT.NONE);
        //panel.setBackground(new Color(Display.getCurrent(),255,255,0));

        panel.setLayout(new GridLayout(2, true));
        isParseLinkButton = new Button(panel, SWT.CHECK);
        
        GridData gdata1 = new GridData();
        gdata1.horizontalSpan = 2;
        isParseLinkButton.setLayoutData(gdata1);

        isParseLinkButton.setText("link쐬");
        //isParseLinkButton.addSelectionListener(this);
        settingItem.setControl(panel);

        //Composite splitPanel=new Composite(panel,SWT.NULL);
        //splitPanel.setLayout(new FillLayout(SWT.HORIZONTAL));
        Label splitLabel = new Label(panel, SWT.NULL);
        splitLabel.setText("");
        splitWordText = new Combo(panel, SWT.BORDER);
        splitWordText.add(",");
        //splitWordText.addModifyListener(this);
        
        GridData gdata2 = new GridData();
        gdata2.horizontalAlignment = GridData.FILL;
        splitWordText.setLayoutData(gdata2);

        Label returnLabel = new Label(panel, SWT.NULL);
        returnLabel.setText("s");

        list = new Combo(panel, SWT.READ_ONLY);
        
        list.add("OS ftHg ");
        list.add("Unix(\\n)");
        list.add("Win(\\r\\n)");
        list.add("Mac(\\r)");
        
        //list.addSelectionListener(this);

        
        
        updateButton = new Button(panel,SWT.NULL);
        updateButton.setText("XV");
        //updateButton.addSelectionListener(this);
        
        
        
        
        statusChangeMonitor=(StatusChangeMonitor) picoContainer.getComponentInstanceOfType(StatusChangeMonitor.class);
        statusChangeMonitor.addSelectableItem(list);
        statusChangeMonitor.addSelectableItem(isParseLinkButton);
        //statusChangeMonitor.addSelectableItem(splitWordText);
        statusChangeMonitor.addModifiableItem(splitWordText);
        
        statusChangeMonitor.addUpdateControlItem(updateButton);
        statusChangeMonitor.addEnableControlItem(updateButton);
        statusChangeMonitor.setStatusChangeListener(this);
        statusChangeMonitor.setChanged(false);
    }
    
    /**
     * @param isIndex2
     * @return
     */
    private File createTakahashiMethod(boolean isIndex2) {
        try {
            String base=IOUtils.toString(Main.class.getClassLoader().getResourceAsStream("org/jpn/xucker/tab2tree/takahashi_oop.html"));
            
            StringTreeBuilder builder = new StringTreeBuilder();
            StringTree stringTree = builder.create(textText.getText());
            if(textText.getText().length()==0){
                return null;
            }
            //stirng tree to map.
            String text[]=StringTreeUtils.toTakahashiMethod(stringTree,isIndex2);
           // System.out.println(text[0]);
            //String title="hello";
            String title=StringUtils.replace(text[0],"\\n"," ");
            String body="";
            //System.out.println("title:"+title);
            for(int i=0;i<text.length;i++){
                String tmp=StringUtils.replace(text[i],"\\n","\r\n");
                if(body.length()>0){
                    body+="----\r\n"+tmp+"\r\n";
                }else{
                    body+=tmp+"\r\n";
                }
            }
            base=StringUtils.replace(base,"$TITLE",title);
            base=StringUtils.replace(base,"$TEXT",body);
            //System.out.println(base);
            //write map.
            File baseFile=new File(System.getProperty("user.home"));
            if(new File(baseFile,"My Documents").exists()){
                baseFile=new File(baseFile,"My Documents");
            }
            
           
                try {
                    File tmp=createTmpHtml(baseFile);
                    if(tmp==null){
                        return null;
                    }
                    /*
                    if(tmp.getName().toLowerCase().indexOf(".mm")==-1){
                        tmp=new File(tmp.getParentFile(),tmp.getName()+".mm");
                    }*/
                    FileWriter writer=new FileWriter(tmp);
                    writer.write(base);
                    writer.close();
                    return tmp;
                } catch (IOException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
                return null;
            
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
        return null;
        
      
    }
    
    private File createTmpHtml(File baseFile) {
        String name="takahashi";
        File tmpFile=null;
        for(int i=1;i<10000;i++){
            tmpFile=new File(baseFile,name+toNum(i)+".html");
            if(!tmpFile.exists()){
                return tmpFile;
            }
        }
        return null;
    }
    private String toNum(int num){
        String v=""+num;
        while(v.length()<4){
            v="0"+v;
        }
        return v;
    }
    
  
    public class TakahashiMethodSelect implements SelectionListener{
        private boolean isIndex;
        
        public TakahashiMethodSelect(boolean bool){
            isIndex=bool;
        }
        /* (non-Javadoc)
         * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
         */
        public void widgetSelected(SelectionEvent e) {
            
            File mmFile=createTakahashiMethod(isIndex);
            if(mmFile!=null){
            Program.launch(mmFile.getAbsolutePath());
            }
        }

       
        /* (non-Javadoc)
         * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
         */
        public void widgetDefaultSelected(SelectionEvent e) {
            // TODO Auto-generated method stub
            
        }
    }
        
   
    public class CallMind implements SelectionListener{

        /* (non-Javadoc)
         * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
         */
        public void widgetSelected(SelectionEvent e) {
            
            File mmFile=createFreeMind();
            
            Program.launch(mmFile.getAbsolutePath());
        }

        /* (non-Javadoc)
         * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
         */
        public void widgetDefaultSelected(SelectionEvent e) {
            // TODO Auto-generated method stub
            
        }
        
        private File createFreeMind() {
            
            StringTreeBuilder builder = new StringTreeBuilder();
            StringTree stringTree = builder.create(textText.getText());
            if(textText.getText().length()==0){
                return null;
            }
            //stirng tree to map.
            Map map=StringTreeUtils.toFreeMind(stringTree);
            //write map.
            File baseFile=new File(System.getProperty("user.home"));
            if(new File(baseFile,"My Documents").exists()){
                baseFile=new File(baseFile,"My Documents");
            }
            
           
                try {
                    File tmp=createTmpFile(baseFile);
                    if(tmp==null){
                        return null;
                    }
                    /*
                    if(tmp.getName().toLowerCase().indexOf(".mm")==-1){
                        tmp=new File(tmp.getParentFile(),tmp.getName()+".mm");
                    }*/
                    FileWriter writer=new FileWriter(tmp);
                    FreeMindUtils.writeMap(writer,map);
                    writer.close();
                    return tmp;
                } catch (IOException e) {
                    // TODO Auto-generated catch block
                    e.printStackTrace();
                }
                return null;
            }

        /**
         * @param baseFile
         * @return
         */
        private File createTmpFile(File baseFile) {
            String name="tabmind";
            File tmpFile=null;
            for(int i=1;i<10000;i++){
                tmpFile=new File(baseFile,name+toNum(i)+".mm");
                if(!tmpFile.exists()){
                    return tmpFile;
                }
            }
            return null;
        }
        private String toNum(int num){
            String v=""+num;
            while(v.length()<4){
                v="0"+v;
            }
            return v;
        }
           
        
        
    }
    public void updateUi(){
        if(isParseLinkButton!=null && splitWordText!=null && list!=null){
        if (applicationProperties.getBoolean(ISLINK)) {
            isParseLinkButton.setSelection(true);
        }else{
            isParseLinkButton.setSelection(false);
        }
        
        splitWordText.setText(applicationProperties.get(SPLIT_WORD));
        
        if (applicationProperties.get(LINE_SEPARATOR).equals("n")) {
            list.select(1);
        } else if (applicationProperties.get(LINE_SEPARATOR).equals("rn")) {
            list.select(2);
        } else if (applicationProperties.get(LINE_SEPARATOR).equals("r")) {
            list.select(3);
        } else {
            list.select(0);
        }
        
        statusChangeMonitor.setChanged(false);
        }
    }

    public String getLineSeparator() {
        if (list.getSelectionIndex() == 1) {
            return "\n";
        } else if (list.getSelectionIndex() == 2) {
            return "\r\n";
        } else if (list.getSelectionIndex() == 3) {
            return "\r";
        } else {
            return System.getProperty("line.separator");
        }
    }


    public MutablePicoContainer loadContainer(){
        
        MutablePicoContainer container=new DefaultPicoContainer();
        File propertyFile=new File(ApplicationUtil.searchFileAroundClass(EXE_NAME).getParent(),"tab2tree.priperties");
        
        container.registerComponentImplementation(FileProperties.class,FileProperties.class,new Parameter[]{new ConstantParameter(propertyFile)});
        
        
        container.registerComponentImplementation(SWTStatusChangedMonitor.class);
        
        return container;
    }
    /**
     *  
     */
    private void loadProperties() {
        applicationProperties = (ApplicationProperties)picoContainer.getComponentInstanceOfType(ApplicationProperties.class);
        
        String defaultSplitWord=",";
        boolean defaultIsLink=true;
        String defaultLineSeparator="os";
//      init
        applicationProperties.set(SPLIT_WORD,defaultSplitWord);
        applicationProperties.setBoolean(ISLINK,defaultIsLink);
        applicationProperties.set(LINE_SEPARATOR,defaultLineSeparator);
        applicationProperties.load();
        
       
           
           
           
       
    }

    private void saveProperties() {
        applicationProperties.save();
    }



    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
     */
    public void widgetSelected(SelectionEvent item) {
        if (item.getSource() instanceof MenuItem) {
            MenuItem menuItem = (MenuItem) item.getSource();
            //System.out.println(menuItem.getText());
            if ("I".equals(menuItem.getText())) {
                exit();
            } else if ("VK".equals(menuItem.getText())) {
                newFile();
            } else if ("J".equals(menuItem.getText())) {
                openFile();
            } else if ("ۑ".equals(menuItem.getText())) {
                saveFile();
            } else if ("ʖŕۑ".equals(menuItem.getText())) {
                saveAsFile();
            } else if ("t@C֕ۑ".equals(menuItem.getText())) {
                doWriteFile();
            } else if ("Nbv{[hփRs[".equals(menuItem.getText())) {
                doCopy();
            } else if ("z[y[W\".equals(menuItem.getText())) {
                doHomepage();
            } else if ("o[W".equals(menuItem.getText())) {
                doVersion();
            }else if("FreeMind `ŏo".equals(menuItem.getText())){
                doFreeMind();
                
            }

        } else if (item.getSource() instanceof TabFolder) {
        
            int index = tab.getSelectionIndex();
            if (index == 1) {
                
                execTab2Tree();
            }else{
                updateUi();
            }
        }else if (item.getSource() ==isParseLinkButton || item.getSource() ==list) {
            statusChanged();
        }
    }

    /**
     * 
     */
    private void doFreeMind() {
        
        StringTreeBuilder builder = new StringTreeBuilder();
        StringTree stringTree = builder.create(textText.getText());
        //stirng tree to map.
        Map map=StringTreeUtils.toFreeMind(stringTree);
        //write map.
        FileDialog dialog=new FileDialog(shell,SWT.SAVE);
        dialog.setFilterExtensions(new String[]{"*.mm"});
        String path=dialog.open();
        if(path!=null){
            try {
                File tmp=new File(path);
                /*
                if(tmp.getName().toLowerCase().indexOf(".mm")==-1){
                    tmp=new File(tmp.getParentFile(),tmp.getName()+".mm");
                }*/
                FileWriter writer=new FileWriter(tmp);
                FreeMindUtils.writeMap(writer,map);
                writer.close();
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
       
    }
    /**
     *  
     */
    private void execTab2Tree() {
        // TODO Auto-generated method stub
        StringTreeBuilder builder = new StringTreeBuilder();
        StringTree stringTree = builder.create(textText.getText());
        TabToTreeView view = new TabToTreeView();

        view.setSplitWord(splitWordText.getText());
        view.setLink(isParseLinkButton.getSelection());
        //view.setLineSeparator(getLineSeparator());

        String treeText = view.view(stringTree);
        this.treeText.setText(treeText);
    }

    /**
     *  
     */
    /*
    private void checkSave() {
        if (splitWordText != null) {
            if (splitWordText.getText().equals("")) {
                splitWordText.setText(","); //default value
            }

            if (!ap.equals(splitWordText.getText())
                    || isParseLinkButton.getSelection() != isLink
                    || getLineSeparatorKey() != lineSeparator) {
                
                applicationProperties.set(SPLIT_WORD,splitWordText.getText());
                applicationProperties.setBoolean(SPLIT_WORD,isParseLinkButton.getSelection());
                applicationProperties.set(LINE_SEPARATOR,getLineSeparatorKey());

                saveProperties();
            }
        }
    }*/

    /**
     * @return
     */
    private String getLineSeparatorKey() {
        String lineSeparator = "os";
        if (list.getSelectionIndex() == 1) {
            lineSeparator = "n";
        } else if (list.getSelectionIndex() == 2) {
            lineSeparator = "rn";
        } else if (list.getSelectionIndex() == 3) {
            lineSeparator = "r";
        }
        return lineSeparator;
    }

    /**
     *  
     */
    private void doVersion() {
        MessageBox box = new MessageBox(shell, SWT.OK | SWT.ICON_INFORMATION);
        box.setMessage("Tab2Tree eLXg " + version + "\r\n\r\n"
                + "License CPL or Apache2.0\r\n (c)AbL[  2004\r\n"
                + "http://www.xucker.jpn.org/product/tab2tree.html");

        //int result=box.open();
        //never use result int,for PMD
        box.open();
    }

    /**
     *  
     */
    private void doHomepage() {
        // TODO Auto-generated method stub

    }

   

    /**
     *  
     */
    private void doCopy() {
        execTab2Tree();
        String result = treeText.getText();
        //System.out.println((int)Text.DELIMITER.charAt(0));
        //System.out.println((int)getLineSeparator().charAt(0));
        result = result.replaceAll(System.getProperty("line.separator"),
                getLineSeparator());
        Clipboard cp = Toolkit.getDefaultToolkit().getSystemClipboard();
        cp.setContents(new StringSelection(result), null);
    }

    /**
     *  
     */
    private void doWriteFile() {
        execTab2Tree();
        String result = treeText.getText();
        result = result.replaceAll(System.getProperty("line.separator"),
                getLineSeparator());

        FileDialog dialog = new FileDialog(shell, SWT.SAVE);
        String select = dialog.open();
        if (select != null) {
            try {
                FileUtils.writeStringToFile(new File(select), result,
                        FileEncoding);
            } catch (IOException e) {

                e.printStackTrace();
            }
        }

    }

   



    public void readText(File openFile) {
        if (openFile.exists()) {
            try {
                String text = FileUtils
                        .readFileToString(openFile, FileEncoding);
                textText.setText(text);
                
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

    }

    public void execOpen() {
        if (getFile() != null) {

            readText(getFile());
        }
        
       
    }

    

    /**
     *  
     */
    protected void execSave() {
        try {
            FileUtils.writeStringToFile(getFile(), textText.getText(),
                    FileEncoding);
            
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
    }

   

    

 

    /**
     *  
     */

    protected void execNew() {
        textText.setText("");
        
      
    }

    

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
     */
    public void widgetDefaultSelected(SelectionEvent arg0) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.ModifyListener#modifyText(org.eclipse.swt.events.ModifyEvent)
     */
    public void modifyText(ModifyEvent event) {
        if(event.getSource()==updateButton){
        statusChanged();
        }else{
        setNeedSave(true);
        updateTitle();
        }
    }

    /**
     * 
     */
    private void statusChanged() {
        updateButton.setEnabled(true);
    }
    /**
     * 
     */
    protected void updateTitle() {
        // TODO Auto-generated method stub
        String mark=" - ";
        if(isNeedSave()){
            mark+="*";
        }
        shell.setText(appName+mark+getFileName());
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.ShellListener#shellActivated(org.eclipse.swt.events.ShellEvent)
     */
    public void shellActivated(ShellEvent arg0) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.ShellListener#shellClosed(org.eclipse.swt.events.ShellEvent)
     * 
     * 
     */
    public void shellClosed(ShellEvent event) {
       
        if (isNeedSave()) {
            if(isNeedSave()){
                int result=askSave();
                if(result==YES){
                if(!saveFile()){
                    event.doit=false;
                    return; //cancel
                }
                }else if(result==CANCEL){
                    event.doit=false;
                    return;
                }
            }
        } 
        event.doit=true;
    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.ShellListener#shellDeactivated(org.eclipse.swt.events.ShellEvent)
     */
    public void shellDeactivated(ShellEvent arg0) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.ShellListener#shellDeiconified(org.eclipse.swt.events.ShellEvent)
     */
    public void shellDeiconified(ShellEvent arg0) {
        // TODO Auto-generated method stub

    }

    /*
     * (non-Javadoc)
     * 
     * @see org.eclipse.swt.events.ShellListener#shellIconified(org.eclipse.swt.events.ShellEvent)
     */
    public void shellIconified(ShellEvent arg0) {
        // TODO Auto-generated method stub

    }

    

  
    public void exit(){
        
        execExit();
    }

    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.util.AbstractBasicFileApplication#execExit()
     */
    protected void execExit() {
        //System.out.println("execExit");
        shell.close();
    }
    /* (non-Javadoc)
     * @see org.jpn.xucker.commons.util.StatusChangeListener#statusChanged(boolean)
     */
    public void statusChanged(boolean changed) {
        System.out.println(""+changed);
        if(changed){
        applicationProperties.setBoolean(ISLINK,isParseLinkButton.getSelection());
        applicationProperties.set(LINE_SEPARATOR,getLineSeparatorKey());
        applicationProperties.set(SPLIT_WORD,splitWordText.getText());
        applicationProperties.save();
        }
    }


   
   

}