/*
 * Created on 2004/10/20
 * Author aki@www.xucker.jpn.org
 * License Apache2.0 or Common Public License
 */
package org.jpn.xucker.tab2tree;

import java.util.ArrayList;
import java.util.List;

import org.jpn.xucker.freemind.Map;
import org.jpn.xucker.freemind.Node;
import org.jpn.xucker.tree.StringTree;

/**
 * 
 *
 */
public class StringTreeUtils {
    private StringTreeUtils(){};
   public static Map toFreeMind(StringTree tree){
       Map map=new Map();
       if(tree.countChildren()>0){
       StringTree child=tree.getStringTreeAt(0);
       Node node=new Node(child.getTitle());
       map.addNode(node);
       addChildren(node,child);
       }
       return map;
   }

/**
 * @param node
 * @param child
 */
private static void addChildren(Node node, StringTree child) {
    // TODO Auto-generated method stub
    for(int i=0;i<child.countChildren();i++){
        Node childNode=new Node(child.getStringTreeAt(i).getTitle());
        node.addNode(childNode);
        addChildren(childNode,child.getStringTreeAt(i));
        
    }
}
/**
 * @param stringTree
 * @return
 */
public static String[] toTakahashiMethod(StringTree stringTree,boolean index) {
    // TODO Auto-generated method stub
    List stringList=new ArrayList();
    
    for(int i=0;i<stringTree.countChildren();i++){
        StringTree child=stringTree.getStringTreeAt(i);
        stringList.add(child.getTitle());
        if(index){
            addTakahashiChildren(stringList,child,"");
        }else{
            addTakahashiChildren(stringList,child,null);
        }
        
        }
    
    return (String[])stringList.toArray(new String[stringList.size()]);
}
/**
 * @param stringList
 * @param child
 * @param index
 */
private static void addTakahashiChildren(List stringList, StringTree child,String index) {
    for(int i=0;i<child.countChildren();i++){
        String label=null;
        if(index!=null){
            
            if(index.length()>0){
            label=index+"-"+(i+1);
            }else{
                label=""+(i+1);
            }
            
            stringList.add("("+label+")");
            
            
        }
        String values[]=child.getStringTreeAt(i).getTitle().split("\\|");
        for(int j=0;j<values.length;j++){
            stringList.add(values[j]);
        }
        
        addTakahashiChildren(stringList,child.getStringTreeAt(i),label);
    }
}
   
}
